<template>
  <el-col :span="12">
    <el-card v-loading="!taskDefinitionKey" class="box-card">
      <div slot="header" class="clearfix">
        <span class="el-icon-picture-outline">审批任务</span>
      </div>
      <el-form label-width="100px" ref="formRef" :model="form">
        <el-form-item
          label="审批建议"
          style="margin-bottom: 20px"
          :rules="{
            required: true,
            message: '请选择',
            trigger: 'change'
          }"
        >
          <el-input
            type="textarea"
            v-model="form.reason"
            placeholder="请输入审批建议"
          />
        </el-form-item>
      </el-form>

      <div style="margin-left: 10%; margin-bottom: 20px; font-size: 14px">
        <el-button
          icon="el-icon-edit-outline"
          type="success"
          size="mini"
          @click="handleAudit(1)"
          >通过
        </el-button>

        <el-button
          icon="el-icon-circle-close"
          type="danger"
          size="mini"
          @click="handleAudit(0)"
          >驳回
        </el-button>
      </div>
    </el-card>
  </el-col>
</template>
<script>
  import { approveTaskWithVariables } from '@/api/bpm/task';
  import storageApi from '@/api/warehouseManagement';
  export default {
    data() {
      return {
        form: {}
      };
    },
    props: {
      businessId: {
        default: ''
      },
      taskId: {
        default: ''
      },
      id: {
        default: ''
      },
      taskDefinitionKey: {
        default: ''
      }
    },
    methods: {
      handleAudit(status) {
        if (!this.form.reason && status == 1) {
          this.$message.warning(`请填写审批意见！`);
          return;
        }

        this._approveTaskWithVariables(status);
      },
      async _approveTaskWithVariables(status) {
        console.log(status);
        if (status == 1) {
          if (this.taskDefinitionKey === 'storage') {
            const res = await storageApi.allot({ applyId: this.businessId });
            if (res.data.code != '-1') {
              const params = {
                id: this.taskId,
                reason: this.form.reason,
                variables: { pass: true }
              };
              const data = await approveTaskWithVariables(params);
              if (data.data.code != '-1') {
                this.$emit('handleAudit', {
                  status,
                  title: '通过'
                });
              }
            }
          } else {
            const params = {
              id: this.taskId,
              reason: this.form.reason,
              variables: { pass: true }
            };
            const data = await approveTaskWithVariables(params);
            if (data.data.code != '-1') {
              this.$emit('handleAudit', {
                status,
                title: '通过'
              });
            }
          }
        } else {
          if (this.taskDefinitionKey === 'outbound') {
            const data = await storageApi.notAllotPass({
              id: this.businessId,
              reason: this.form.reason,
              taskId: this.taskId
            });
            if (data.data.code != '-1') {
              this.$emit('handleAudit', {
                status,
                title: '驳回'
              });
            }
          } else {
            const params = {
              id: this.taskId,
              reason: this.form.reason,
              variables: { pass: false }
            };
            const data = await approveTaskWithVariables(params);
            if (data.data.code != '-1') {
              this.$emit('handleAudit', {
                status,
                title: '驳回'
              });
            }
          }
        }
      }
    }
  };
</script>
